using HslCommunication;
using Sln.Iot.PLC;
using Sln.Iot.Repository.service;
using Sln.Iot.Serilog;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Sln.Iot.Business
{
    public class RFID06Business
    {
        private Timer _timer;

        private readonly PLCConnect _plc = PLCConnect.Instance;

        private readonly SerilogHelper _log = SerilogHelper.Instance;

        public RFID06Business()
        {
            _timer = new Timer(TimerCallback, null, 0, 5000);
        }

        /// <summary>
        /// RFID06下料提升机数据处理流程
        /// </summary>
        /// <param name="state"></param>
        public void TimerCallback(object? state)
        {
            // 定时任务逻辑
            //读取信号
            OperateResult<short> signalRes = _plc.ReadInt16(_plc.DeltaInstance3, "D500");
            //成功验证
            if (signalRes.IsSuccess)
            {
                short signalValue = signalRes.Content;
                //如果有读取信号
                if (signalValue == 6001)
                {
                    //读取托盘码和产品码
                    OperateResult<byte[]> trayBytesResult = _plc.ReadBytes(_plc.DeltaInstance3, "D5000", 20);
                    //成功验证
                    if (trayBytesResult.IsSuccess)
                    {
                        //转换托盘吗
                        string traycode = Encoding.ASCII.GetString(trayBytesResult.Content);

                        //sql更新

                        //待开发

                        bool res = TrayBindingService.Instance.TrayCodeDelete(traycode);
                        
                        if (!res)
                        {
                            _log.Error("下料提升机绑定数据删除异常或删除条数为0");
                        }

                        //写入完成信号
                        res = _plc.PlcWrite(_plc.DeltaInstance3, "D500", 6002, DataTypeEnum.UInt16).IsSuccess;
                        if (!res)
                        {
                            _log.Error("下料提升机PLC写入完成信号异常");
                        }
                    }
                    //流程完成
                }
            }
            else
            {
                _log.Error("下料提升机PLC读取信号异常");
            }
        }
    }
}
